diff --git a/src/main/java/net/minecraft/core/entity/Mob.java b/src/main/java/net/minecraft/core/entity/Mob.java
index bac30820c..e8a613df7 100644
--- a/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/src/main/java/net/minecraft/core/entity/Mob.java
@@ -1103,7 +1103,7 @@ public abstract class Mob extends Entity
         }
         if(currentTarget != null)
         {
-            lookAt(currentTarget, 10F, func_25026_x());
+            lookAt(currentTarget, 10F, getLookingTilt());
             if(numTicksToChaseTarget-- <= 0 || currentTarget.removed || currentTarget.distanceToSqr(this) > (double)(f * f))
             {
                 currentTarget = null;
@@ -1125,20 +1125,20 @@ public abstract class Mob extends Entity
         }
     }
 
-    protected int func_25026_x()
+    protected int getLookingTilt()
     {
         return 40;
     }
 
-    public void lookAt(Entity entity, float f, float f1)
+    public void lookAt(Entity entity, float yRot, float xRot)
     {
         double x = entity.x - this.x;
         double y = entity.z - z;
         double y2;
         if(entity instanceof Mob)
         {
-            Mob entityliving = (Mob)entity;
-            y2 = entityliving.y + entityliving.getHeadHeight() - (this.y + this.getHeadHeight());
+            Mob mob = (Mob)entity;
+            y2 = mob.y + mob.getHeadHeight() - (this.y + this.getHeadHeight());
         } else
         {
             y2 = (entity.bb.minY + entity.bb.maxY) / 2D - (this.y + (double) getHeadHeight());
@@ -1146,8 +1146,8 @@ public abstract class Mob extends Entity
         double d3 = MathHelper.sqrt(x * x + y * y);
         float f2 = (float)((Math.atan2(y, x) * 180D) / Math.PI) - 90F;
         float f3 = (float)(-((Math.atan2(-y2, d3) * 180D) / Math.PI));
-        xRot = -rotationLerp(xRot, f3, f1);
-        yRot = rotationLerp(yRot, f2, f);
+        this.xRot = -rotationLerp(this.xRot, f3, xRot);
+        this.yRot = rotationLerp(this.yRot, f2, yRot);
     }
 
     public boolean hasCurrentTarget()
diff --git a/src/main/java/net/minecraft/core/entity/animal/SheepMob.java b/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
index c1b5a0639..ffbbafb9b 100644
--- a/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
@@ -12,6 +12,7 @@ import net.minecraft.core.item.ToolShearsItem;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -171,7 +172,7 @@ public class SheepMob extends Animal
 			if (prevTimeSheepEating == 35) {
 				if(blockBelow == Blocks.GRASS || blockBelow == Blocks.GRASS_RETRO) {
 					if(!world.isClientSide) {
-						world.playBlockEvent(null, 2001, (int) x, (int) y - 1, (int) z, world.getBlockId((int) x, (int) y - 1, (int) z));
+						world.playBlockEvent(null, LevelListener.EVENT_BLOCK_BREAK, (int) x, (int) y - 1, (int) z, world.getBlockId((int) x, (int) y - 1, (int) z));
 						world.setBlockWithNotify(blockX, blockY - 1, blockZ, Blocks.DIRT.id);
 						setSheared(false);
 					}
diff --git a/src/main/java/net/minecraft/core/entity/animal/WolfMob.java b/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
index d59564663..dceeb8b99 100644
--- a/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
@@ -65,12 +65,6 @@ public class WolfMob extends Animal
         setSize(0.8F, 0.8F);
         moveSpeed = 1.1F;
         scoreValue = 500;
-
-        if(!isWolfTamed()){
-            if(random.nextInt(100) == 0){
-                setWolfHeldItem(new ItemStack(Items.RECORD_DOG, 1));
-            }
-        }
     }
 
     @Override
@@ -87,6 +81,13 @@ public class WolfMob extends Animal
         return super.sendDeathMessage(entityKilledBy) || isWolfTamed();
     }
 
+    @Override
+    public void spawnInit() {
+        if(random.nextInt(25 /*Used to be 100, but I think having it that high would make it excessively rare*/) == 0){
+            setWolfHeldItem(new ItemStack(Items.RECORD_DOG, 1));
+        }
+    }
+
     public ArmorMaterial getArmorMaterial() {
         ArmorMaterial material = null;
         String name = entityData.getString(DATA_ARMOR_MATERIAL);
@@ -516,14 +517,14 @@ public class WolfMob extends Animal
     }
 
     @Override
-	protected int func_25026_x()
+	protected int getLookingTilt()
     {
         if(isWolfSitting())
         {
             return 20;
         } else
         {
-            return super.func_25026_x();
+            return super.getLookingTilt();
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/entity/monster/GhastMob.java b/src/main/java/net/minecraft/core/entity/monster/GhastMob.java
index 1a3f1c49f..f7725159b 100644
--- a/src/main/java/net/minecraft/core/entity/monster/GhastMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/GhastMob.java
@@ -132,9 +132,9 @@ public class GhastMob extends FlyingMob
             courseChangeCooldown += random.nextInt(5) + 2;
             if(isCourseTraversable(waypointX, waypointY, waypointZ, d3))
             {
-                xd += (d / d3) * 0.10000000000000001D;
-                yd += (d1 / d3) * 0.10000000000000001D;
-                zd += (d2 / d3) * 0.10000000000000001D;
+                xd += (d / d3) * 0.1D;
+                yd += (d1 / d3) * 0.1D;
+                zd += (d2 / d3) * 0.1D;
             } else
             {
                 waypointX = x;
diff --git a/src/main/java/net/minecraft/core/entity/monster/Monster.java b/src/main/java/net/minecraft/core/entity/monster/Monster.java
index 2c3de6be6..4c7860151 100644
--- a/src/main/java/net/minecraft/core/entity/monster/Monster.java
+++ b/src/main/java/net/minecraft/core/entity/monster/Monster.java
@@ -127,9 +127,9 @@ public abstract class Monster extends PathfinderMob
     }
 
     @Override
-	protected float getBlockPathWeight(int i, int j, int k)
+	protected float getBlockPathWeight(int x, int y, int z)
     {
-        return 0.5F - world.getLightBrightness(i, j, k);
+        return 0.5F - world.getLightBrightness(x, y, z);
     }
 
     @Override
@@ -147,14 +147,14 @@ public abstract class Monster extends PathfinderMob
     @Override
 	public boolean canSpawnHere()
     {
-        int i = MathHelper.floor(x);
-        int j = MathHelper.floor(bb.minY);
-        int k = MathHelper.floor(z);
-        if(world.getSavedLightValue(LightLayer.Block, i, j, k) > 0) return false;
-        if(world.getSavedLightValue(LightLayer.Sky, i, j, k) > random.nextInt(32))
+        int blockX = MathHelper.floor(x);
+        int blockY = MathHelper.floor(bb.minY);
+        int blockZ = MathHelper.floor(z);
+        if(world.getSavedLightValue(LightLayer.Block, blockX, blockY, blockZ) > 0) return false;
+        if(world.getSavedLightValue(LightLayer.Sky, blockX, blockY, blockZ) > random.nextInt(32))
             return false;
 
-        int blockLight = world.getBlockLightValue(i, j, k);
+        int blockLight = world.getBlockLightValue(blockX, blockY, blockZ);
         if(world.getCurrentWeather() != null && world.getCurrentWeather().doMobsSpawnInDaylight)
             blockLight = blockLight/2;
 
diff --git a/src/main/java/net/minecraft/core/entity/player/Player.java b/src/main/java/net/minecraft/core/entity/player/Player.java
index 2bdfb5881..f2ac316d3 100644
--- a/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -46,6 +46,7 @@ import net.minecraft.core.entity.vehicle.MinecartEntity;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.EnumSleepStatus;
+import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
@@ -194,7 +195,7 @@ public abstract class Player extends Mob
     @Override
     public boolean canSkate() 
     {
-        return inventory.armorInventory[0] != null && inventory.armorInventory[0].itemID == Items.ARMOR_BOOTS_ICESKATES.id;
+        return inventory.armorInventory[IArmorItem.PIECE_BOOTS] != null && inventory.armorInventory[IArmorItem.PIECE_BOOTS].itemID == Items.ARMOR_BOOTS_ICESKATES.id;
     }
 
     @Override
@@ -1606,7 +1607,7 @@ public abstract class Player extends Mob
     }
     public Item getNextArrow(){
         Item nextArrow = null;
-        ItemStack quiverSlot = inventory.armorItemInSlot(2);
+        ItemStack quiverSlot = inventory.armorItemInSlot(IArmorItem.PIECE_CHEST);
         if(quiverSlot != null && quiverSlot.itemID == Items.ARMOR_QUIVER.id && quiverSlot.getMetadata() < quiverSlot.getMaxDamage()){
             nextArrow = Items.AMMO_ARROW;
         }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
index 01b04f7db..6a0baca1c 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
@@ -40,6 +40,7 @@ public class FireballProjectile extends Projectile
         setSize(1.0F, 1.0F);
         moveTo(owner.x, owner.y, owner.z, owner.yRot, owner.xRot);
         setPos(x, y, z);
+        this.owner = owner;
         heightOffset = 0.0F;
         vX += (random.nextGaussian() - random.nextGaussian()) * 0.8D;
         vY += (random.nextGaussian()) * 0.4D;
diff --git a/src/main/java/net/minecraft/core/item/BowItem.java b/src/main/java/net/minecraft/core/item/BowItem.java
index 54af1774f..317f63c33 100644
--- a/src/main/java/net/minecraft/core/item/BowItem.java
+++ b/src/main/java/net/minecraft/core/item/BowItem.java
@@ -24,9 +24,9 @@ public class BowItem extends Item
     @Override
     public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
-        ItemStack quiverSlot = entityplayer.inventory.armorItemInSlot(2);
+        ItemStack quiverSlot = entityplayer.inventory.armorItemInSlot(IArmorItem.PIECE_CHEST);
         if(quiverSlot != null && quiverSlot.itemID == Items.ARMOR_QUIVER.id && quiverSlot.getMetadata() < quiverSlot.getMaxDamage()){
-            entityplayer.inventory.armorItemInSlot(2).damageItem(1, entityplayer);
+            entityplayer.inventory.armorItemInSlot(IArmorItem.PIECE_CHEST).damageItem(1, entityplayer);
             itemstack.damageItem(1, entityplayer);
             world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
             if (!world.isClientSide) {
diff --git a/src/main/java/net/minecraft/core/item/DoorItem.java b/src/main/java/net/minecraft/core/item/DoorItem.java
index 24df706cd..0bddb3b68 100644
--- a/src/main/java/net/minecraft/core/item/DoorItem.java
+++ b/src/main/java/net/minecraft/core/item/DoorItem.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.material.Material;
 
 // Referenced classes of package net.minecraft.src:
@@ -13,6 +14,8 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
+import java.util.Random;
+
 public class DoorItem extends Item {
 	protected final Block doorBlockBottom;
 	protected final Block doorBlockTop;
@@ -25,7 +28,7 @@ public class DoorItem extends Item {
     }
 
 	@Override
-	public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack itemstack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
 			blockX += side.getOffsetX();
 			blockY += side.getOffsetY();
@@ -35,7 +38,7 @@ public class DoorItem extends Item {
 			return false;
 		}
 
-		Direction dir = entityplayer.getHorizontalPlacementDirection(side).rotate(3);
+		Direction dir = player.getHorizontalPlacementDirection(side).rotate(3);
 		int meta = dir.getHorizontalIndex();
 		
 		int xOffset = -dir.getOffsetX();
@@ -64,12 +67,57 @@ public class DoorItem extends Item {
 		world.noNeighborUpdate = false;
 		world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id);
 		world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id);
-		world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, doorBlockBottom, EnumBlockSoundEffectType.PLACE);
-		doorBlockBottom.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, entityplayer, yPlaced);
-		doorBlockTop.onBlockPlacedByMob(world, blockX, blockY + 1, blockZ, side, entityplayer, yPlaced);
-		itemstack.consumeItem(entityplayer);
+		world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, doorBlockBottom, EnumBlockSoundEffectType.PLACE);
+		doorBlockBottom.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
+		doorBlockTop.onBlockPlacedByMob(world, blockX, blockY + 1, blockZ, side, player, xPlaced, yPlaced);
+		itemstack.consumeItem(player);
 		return true;
 	}
 
-	private Material doorMaterial;
+	@Override
+	public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
+			blockX += direction.getOffsetX();
+			blockY += direction.getOffsetY();
+			blockZ += direction.getOffsetZ();
+		}
+		if(!doorBlockBottom.canPlaceBlockAt(world, blockX, blockY, blockZ)) {
+			return;
+		}
+
+		if (!direction.isHorizontal()) direction = Direction.NORTH;
+		Direction dir = direction.rotate(3);
+		int meta = dir.getHorizontalIndex();
+
+		int xOffset = -dir.getOffsetX();
+		int zOffset = -dir.getOffsetZ();
+
+		int isSolidBlockLeft = (world.isBlockNormalCube(blockX - xOffset, blockY, blockZ - zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX - xOffset, blockY + 1, blockZ - zOffset) ? 1 : 0);
+		int isSolidBlockRight = (world.isBlockNormalCube(blockX + xOffset, blockY, blockZ + zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX + xOffset, blockY + 1, blockZ + zOffset) ? 1 : 0);
+		boolean isDoorLeft = world.getBlockId(blockX - xOffset, blockY, blockZ - zOffset) == doorBlockBottom.id || world.getBlockId(blockX - xOffset, blockY + 1, blockZ - zOffset) == doorBlockTop.id;
+		boolean isDoorRight = world.getBlockId(blockX + xOffset, blockY, blockZ + zOffset) == doorBlockBottom.id || world.getBlockId(blockX + xOffset, blockY + 1, blockZ + zOffset) == doorBlockTop.id;
+		boolean isMirrored = false;
+
+		if(isDoorLeft && !isDoorRight) {
+			isMirrored = true;
+		} else if(isSolidBlockRight > isSolidBlockLeft) {
+			isMirrored = true;
+		}
+		if(isMirrored) {
+			meta = meta - 1 & 3;
+			meta += 4;
+			meta |= 0x8;
+		}
+
+		world.noNeighborUpdate = true;
+		world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, doorBlockBottom.id, meta);
+		world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, doorBlockTop.id, meta);
+		world.noNeighborUpdate = false;
+		world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id);
+		world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id);
+		world.playBlockSoundEffect(null, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, doorBlockBottom, EnumBlockSoundEffectType.PLACE);
+		doorBlockBottom.onBlockPlacedOnSide(world, blockX, blockY, blockZ, direction.getSide(), 0.5, 0.5);
+		doorBlockTop.onBlockPlacedOnSide(world, blockX, blockY + 1, blockZ, direction.getSide(), 0.5, 0.5);
+		itemStack.consumeItem(null);
+	}
 }
diff --git a/src/main/java/net/minecraft/core/item/IArmorItem.java b/src/main/java/net/minecraft/core/item/IArmorItem.java
index fd4f9e21a..f5e5cf4fd 100644
--- a/src/main/java/net/minecraft/core/item/IArmorItem.java
+++ b/src/main/java/net/minecraft/core/item/IArmorItem.java
@@ -4,13 +4,13 @@ import net.minecraft.core.item.material.ArmorMaterial;
 import org.jetbrains.annotations.Nullable;
 
 public interface IArmorItem {
-    int PIECE_HEAD = 0;
-    int PIECE_CHEST = 1;
-    int PIECE_LEGS = 2;
-    int PIECE_BOOTS = 3;
-    int[] ARMOR_PIECE_PROTECTION_VALUES = new int[] {3, 8, 6, 3};
+    int PIECE_HEAD = 3;
+    int PIECE_CHEST = 2;
+    int PIECE_LEGS = 1;
+    int PIECE_BOOTS = 0;
+    int[] ARMOR_PIECE_PROTECTION_VALUES = new int[] {3, 6, 8, 3};
 
-    float[] ARMOR_PIECE_DURABILITY_MODIFIERS = new float[] {0.91f, 1.0f, 0.97f, 0.94f};
+    float[] ARMOR_PIECE_DURABILITY_MODIFIERS = new float[] {0.94f, 0.97f, 1.0f, 0.91f};
     Item asItem(); // Ensure this has the same signature as Item's Item.asItem
     @Nullable
     ArmorMaterial getArmorMaterial();
diff --git a/src/main/java/net/minecraft/core/item/PaintedDoorItem.java b/src/main/java/net/minecraft/core/item/PaintedDoorItem.java
index 2d451cb76..ae0a7e395 100644
--- a/src/main/java/net/minecraft/core/item/PaintedDoorItem.java
+++ b/src/main/java/net/minecraft/core/item/PaintedDoorItem.java
@@ -13,7 +13,7 @@ public class PaintedDoorItem extends DoorItem {
         super(name, namespaceId, id, doorBottom, doorTopId);
     }
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
             blockX += side.getOffsetX();
             blockY += side.getOffsetY();
@@ -23,7 +23,7 @@ public class PaintedDoorItem extends DoorItem {
             return false;
         }
 
-        Direction dir = entityplayer.getHorizontalPlacementDirection(side).rotate(3);
+        Direction dir = player.getHorizontalPlacementDirection(side).rotate(3);
         int meta = dir.getHorizontalIndex();
 
         int xOffset = -dir.getOffsetX();
@@ -53,8 +53,8 @@ public class PaintedDoorItem extends DoorItem {
         world.noNeighborUpdate = false;
         world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id);
         world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id);
-        world.playBlockSoundEffect(entityplayer,blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, doorBlockBottom, EnumBlockSoundEffectType.PLACE);
-        itemstack.consumeItem(entityplayer);
+        world.playBlockSoundEffect(player,blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, doorBlockBottom, EnumBlockSoundEffectType.PLACE);
+        itemstack.consumeItem(player);
         return true;
     }
     @Override
diff --git a/src/main/java/net/minecraft/core/item/PebbleItem.java b/src/main/java/net/minecraft/core/item/PebbleItem.java
index 18758812e..d9b388706 100644
--- a/src/main/java/net/minecraft/core/item/PebbleItem.java
+++ b/src/main/java/net/minecraft/core/item/PebbleItem.java
@@ -11,7 +11,6 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
-import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -114,7 +113,7 @@ public class PebbleItem extends Item implements IDispensable
         {
             if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id, 0))
             {
-                Blocks.OVERLAY_PEBBLES.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
+                Blocks.OVERLAY_PEBBLES.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(player);
 				return true;
diff --git a/src/main/java/net/minecraft/core/item/PlaceableItem.java b/src/main/java/net/minecraft/core/item/PlaceableItem.java
index 76f265a6c..3ee386dbe 100644
--- a/src/main/java/net/minecraft/core/item/PlaceableItem.java
+++ b/src/main/java/net/minecraft/core/item/PlaceableItem.java
@@ -39,9 +39,9 @@ public class PlaceableItem extends Item {
 		if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
 			if(world.setBlockWithNotify(blockX, blockY, blockZ, blockToPlace.id)) {
 				if (player == null) {
-					blockToPlace.onBlockPlacedByWorld(world, blockX, blockY, blockZ);
+					blockToPlace.onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 				} else {
-					blockToPlace.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
+					blockToPlace.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
 				}
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockToPlace, EnumBlockSoundEffectType.PLACE);
 				return true;
diff --git a/src/main/java/net/minecraft/core/item/RopeItem.java b/src/main/java/net/minecraft/core/item/RopeItem.java
index 52366e44b..24047207b 100644
--- a/src/main/java/net/minecraft/core/item/RopeItem.java
+++ b/src/main/java/net/minecraft/core/item/RopeItem.java
@@ -1,16 +1,13 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.RopeBlock;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.Random;
-
 public class RopeItem extends PlaceableItem {
     public RopeItem(String name, String namespaceId, int id, Block blockToPlace) {
         super(name, namespaceId, id, blockToPlace);
@@ -47,11 +44,11 @@ public class RopeItem extends PlaceableItem {
             return false;
         }
         if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
-            if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockToPlace.id, placeOnSide ? 0b1000_0000 : 0)) {
+            if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockToPlace.id, placeOnSide ? RopeBlock.MASK_ROPE_CONNECT : 0)) {
                 if (player == null) {
-                    blockToPlace.onBlockPlacedByWorld(world, blockX, blockY, blockZ);
+                    blockToPlace.onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
                 } else {
-                    blockToPlace.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
+                    blockToPlace.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
                 }
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockToPlace, EnumBlockSoundEffectType.PLACE);
 				return true;
diff --git a/src/main/java/net/minecraft/core/item/block/AlgaeBlockItem.java b/src/main/java/net/minecraft/core/item/block/AlgaeBlockItem.java
index bf4333752..8291ede68 100644
--- a/src/main/java/net/minecraft/core/item/block/AlgaeBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/AlgaeBlockItem.java
@@ -4,7 +4,10 @@ package net.minecraft.core.item.block;
 //            World, MovingObjectPosition, EnumMovingObjectType, Block, 
 //            BoatEntity, ItemStack
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
@@ -16,6 +19,8 @@ import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.Random;
+
 public class AlgaeBlockItem extends BlockItem
 {
 
@@ -75,7 +80,7 @@ public class AlgaeBlockItem extends BlockItem
             Block block = Block.blocksList[Blocks.ALGAE.id];
             if(itemstack.consumeItem(player) && world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.ALGAE.id, 0))
             {
-                Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, 0.0);
+                Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, 0.5, 0.5);
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
                 player.swingItem();
             }
@@ -83,4 +88,17 @@ public class AlgaeBlockItem extends BlockItem
         }
         return itemstack;
     }
+
+    @Override
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        int x = blockX + direction.getOffsetX();
+        int y = blockY + direction.getOffsetY();
+        int z = blockZ + direction.getOffsetZ();
+        Block b = world.getBlock(x, y, z);
+        Block bAbove = world.getBlock(x, y + 1, z);
+        if (b == Blocks.FLUID_WATER_STILL && (bAbove == null || bAbove.hasTag(BlockTags.PLACE_OVERWRITES))) {
+            world.setBlockWithNotify(x, y + 1, z, Blocks.ALGAE.id);
+            Blocks.ALGAE.onBlockPlacedOnSide(world, x, y + 1, z, Side.NONE, 0.5, 0.5);
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/item/block/BlockItem.java b/src/main/java/net/minecraft/core/item/block/BlockItem.java
index 73e3fa9a3..7cfa18ea0 100644
--- a/src/main/java/net/minecraft/core/item/block/BlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/BlockItem.java
@@ -54,9 +54,9 @@ public class BlockItem extends Item
 			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
 				stack.consumeItem(player);
 				if (player == null) {
-                    block.onBlockPlacedByWorld(world, x, y, z);
+                    block.onBlockPlacedOnSide(world, x, y, z, side, xPlaced, yPlaced);
                 } else {
-                    block.onBlockPlacedByMob(world, x, y, z, side, player, yPlaced);
+                    block.onBlockPlacedByMob(world, x, y, z, side, player, xPlaced, yPlaced);
                 }
 				world.playBlockSoundEffect(player, x + 0.5F, y + 0.5F, z + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				return true;
@@ -72,7 +72,9 @@ public class BlockItem extends Item
         int z = blockZ + direction.getOffsetZ();
         Block b = world.getBlock(x, y, z);
         if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
-            onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5);
+            if (onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5)) {
+                getBlock().onBlockPlacedByActivator(world, x, y, z, activatorBlock, direction);
+            }
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java b/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java
index 8ab95f928..e869e8d75 100644
--- a/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java
@@ -28,7 +28,7 @@ public class LadderBlockItem extends BlockItem {
 			while(world.getBlock(x, y, z) == ladderBlock && ladderBlock.getSideFromMeta(world.getBlockMetadata(x, y, z)) == clickedLadderSide) y--;
 			int meta = ladderBlock.getMetaForSide(clickedLadderSide);
 			if(ladderBlock.canExistAt(world, x, y, z, meta)) {
-				return placeBlock(world, x, y, z, meta, player, stack, clickedLadderSide, 0.5);
+				return placeBlock(world, x, y, z, meta, player, stack, clickedLadderSide, 0.5, 0.5);
 			}
 			
 			return false;
@@ -47,16 +47,16 @@ public class LadderBlockItem extends BlockItem {
 		
 		int meta = ladderBlock.getMetaForSide(sideForPlacement);
 		if(ladderBlock.canExistAt(world, x, y, z, meta)) {
-			return placeBlock(world, x, y, z, meta, player, stack, sideForPlacement, yPlaced);
+			return placeBlock(world, x, y, z, meta, player, stack, sideForPlacement, xPlaced, yPlaced);
 		}
 		
 		return false;
 	}
 	
-	public boolean placeBlock(World world, int x, int y, int z, int meta, @Nullable Player player, ItemStack stack, Side side, double sideHeight) {
+	public boolean placeBlock(World world, int x, int y, int z, int meta, @Nullable Player player, ItemStack stack, Side side, double xPlaced, double yPlaced) {
 		if(world.canPlaceInsideBlock(x, y, z) && world.canBlockBePlacedAt(blockID, x, y, z, false, side) && stack.consumeItem(player)) {
 			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
-				Block.getBlock(blockID).onBlockPlacedByMob(world, x, y, z, side, player, sideHeight);
+				Block.getBlock(blockID).onBlockPlacedByMob(world, x, y, z, side, player, xPlaced, yPlaced);
 				world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, ladderBlock, EnumBlockSoundEffectType.PLACE);
 				return true;
 			}
diff --git a/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java b/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java
index 49fa05fed..07c63d6c2 100644
--- a/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java
@@ -130,9 +130,9 @@ public class LayerBlockItem extends BlockItem
 			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
 			{
 				if (player == null) {
-					Block.blocksList[blockID].onBlockPlacedByWorld(world, blockX, blockY, blockZ);
+					Block.blocksList[blockID].onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 				} else {
-					Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, yPlaced);
+					Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, xPlaced, yPlaced);
 				}
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(player);
